//
// Copyright (c) 2016, MindFusion LLC - Bulgaria.
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;


namespace MindFusion.Scheduling.WinForms.Samples.CS.Tutorial3
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private MindFusion.Scheduling.WinForms.Calendar calendar;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
			this.calendar = new MindFusion.Scheduling.WinForms.Calendar();
			((System.ComponentModel.ISupportInitialize)(this.calendar)).BeginInit();
			this.SuspendLayout();
			// 
			// calendar
			// 
			this.calendar.CurrentTime = new System.DateTime(2008, 10, 29, 14, 3, 0, 647);
			this.calendar.CurrentView = MindFusion.Scheduling.WinForms.CalendarView.WeekRange;
			this.calendar.Date = new System.DateTime(2005, 12, 1, 0, 0, 0, 0);
			this.calendar.DateTimeFormat = ((System.Globalization.DateTimeFormatInfo)(resources.GetObject("calendar.DateTimeFormat")));
			this.calendar.Dock = System.Windows.Forms.DockStyle.Fill;
			this.calendar.EndDate = new System.DateTime(2006, 3, 1, 0, 0, 0, 0);
			this.calendar.Location = new System.Drawing.Point(0, 0);
			this.calendar.Name = "calendar";
			this.calendar.Size = new System.Drawing.Size(292, 273);
			this.calendar.TabIndex = 0;
			this.calendar.ItemClick += new System.EventHandler<MindFusion.Scheduling.WinForms.ItemMouseEventArgs>(this.calendar_ItemClick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Controls.Add(this.calendar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.calendar)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			Appointment app = new Appointment();
			app.HeaderText = "Meet George";
			app.DescriptionText = "This is a sample appointment";
			app.StartTime = new DateTime(2006, 1, 10, 14, 0, 0);
			app.EndTime = new DateTime(2006, 1, 10, 16, 30, 0);

			calendar.Schedule.Items.Add(app);

			Recurrence rec = new Recurrence();
			rec.Pattern = RecurrencePattern.Weekly;
			rec.DaysOfWeek = DaysOfWeek.Monday | DaysOfWeek.Wednesday;
			rec.Weeks = 2;
			rec.StartDate = new DateTime(2006, 1, 10);
			rec.RecurrenceEnd = RecurrenceEnd.Never;

			app.Recurrence = rec;
		}

		private void calendar_ItemClick(object sender, MindFusion.Scheduling.WinForms.ItemMouseEventArgs e)
		{
			// Display the form only if left mouse button is double-clicked
			if (e.Button != MouseButtons.Left || e.Clicks != 2)
				return;

			calendar.ResetDrag();

			// Create the form
			AppointmentForm form = new AppointmentForm(calendar.Schedule);
			form.Text = e.Item.HeaderText;
			form.SetAppointment(e.Item as Appointment);

			// Display the form to the user
			DialogResult result = form.ShowDialog(this);

			if (result == DialogResult.Abort)
			{
				// 'Abort' is returned when the user clicks the 'Delete' button.
				// It is up to us to delete the item from the schedule.
				if (e.Item.RecurrenceState == RecurrenceState.Occurrence ||
					e.Item.RecurrenceState == RecurrenceState.Exception)
					e.Item.Recurrence.MarkException(e.Item, true);
				else
					calendar.Schedule.Items.Remove(e.Item);
			}
			// Invalidate the control
			calendar.Invalidate();
		}
	}
}
