//
// Copyright (c) 2016, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;


namespace MindFusion.Scheduling.WinForms.Samples.CS.Tutorial5
{
	/// <summary>
	/// Summary description for MyAppEditor.
	/// </summary>
	public class MyAppEditor : System.Windows.Forms.UserControl, IItemEditor
	{
		private System.Windows.Forms.TextBox headerText;
		private System.Windows.Forms.CheckBox kept;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MyAppEditor()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.headerText = new System.Windows.Forms.TextBox();
			this.kept = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// headerText
			// 
			this.headerText.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.headerText.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.headerText.Location = new System.Drawing.Point(0, 0);
			this.headerText.Name = "headerText";
			this.headerText.Size = new System.Drawing.Size(128, 13);
			this.headerText.TabIndex = 0;
			this.headerText.Text = "";
			// 
			// kept
			// 
			this.kept.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.kept.Location = new System.Drawing.Point(130, 0);
			this.kept.Name = "kept";
			this.kept.Size = new System.Drawing.Size(16, 16);
			this.kept.TabIndex = 1;
			// 
			// MyAppEditor
			// 
			this.Controls.Add(this.kept);
			this.Controls.Add(this.headerText);
			this.Name = "MyAppEditor";
			this.Size = new System.Drawing.Size(144, 13);
			this.ResumeLayout(false);

		}
		#endregion

		public void StartEdit(ItemEditContext context)
		{
			MyApp item = context.Item as MyApp;

			headerText.Text = item.HeaderText;
			kept.Checked = item.Kept;

			headerText.Focus();
			headerText.Select(headerText.Text.Length, 0);
		}

		public void EndEdit(ItemEditContext context, bool accept)
		{
			if (accept)
			{
				context.Accept();

				MyApp item = context.Item as MyApp;

				item.HeaderText = headerText.Text;
				item.Kept = kept.Checked;
			}
			else
			{
				context.Cancel();
			}
		}

		public new string Text
		{
			get { return headerText.Text; }
		}
	}
}
