//
// Copyright (c) 2016, MindFusion LLC - Bulgaria.
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using MindFusion.Scheduling.Reporting;


namespace MindFusion.Scheduling.WinForms.Samples.CS.Tutorial6
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private MindFusion.Scheduling.WinForms.Calendar _calendar;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
			this._calendar = new MindFusion.Scheduling.WinForms.Calendar();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this._calendar)).BeginInit();
			this.SuspendLayout();
			// 
			// _calendar
			// 
			this._calendar.CurrentTime = new System.DateTime(2019, 11, 29, 14, 3, 50, 568);
			this._calendar.Date = new System.DateTime(2019, 11, 1, 0, 0, 0, 0);
			this._calendar.DateTimeFormat = ((System.Globalization.DateTimeFormatInfo)(resources.GetObject("_calendar.DateTimeFormat")));
			this._calendar.EndDate = new System.DateTime(2019, 11, 13, 0, 0, 0, 0);
			this._calendar.GroupType = MindFusion.Scheduling.WinForms.GroupType.GroupByContacts;
			this._calendar.Location = new System.Drawing.Point(8, 8);
			this._calendar.Name = "_calendar";
			this._calendar.Size = new System.Drawing.Size(424, 312);
			this._calendar.TabIndex = 0;
			this._calendar.Theme = MindFusion.Scheduling.WinForms.ThemeType.Silver;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(320, 328);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Create &Report";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(200, 328);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(112, 24);
			this.button2.TabIndex = 1;
			this.button2.Text = "Add &Appointments";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(440, 358);
			this.Controls.Add(this.button1);
			this.Controls.Add(this._calendar);
			this.Controls.Add(this.button2);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Tutorial 6";
			((System.ComponentModel.ISupportInitialize)(this._calendar)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Report report = new Report();

			ReportColumn column = null;

			// Create the first column
			column = report.CreateColumn();
			column.Property = "HeaderText";
			column.Width = 100;
			report.Columns.Add(column);

			// Create the second column
			column = report.CreateColumn();
			column.Property = "StartTime";
			column.Width = 50;
			report.Columns.Add(column);

			// Create the third column
			column = report.CreateColumn();
			column.Property = "EndTime";
			column.Width = 50;
			report.Columns.Add(column);

			report.Schedule = _calendar.Schedule;
			report.Options.AbsoluteColumnWidth = false;

			report.Preview(DateTime.MinValue, DateTime.MaxValue);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			// Create the appointments
			Appointment app;

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "21965 Carbon Mesa Rd (1)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "777 Ocampo Dr (1)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "401 Almar Ave (1)";
			app.Priority = -2;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "16680 Charmel Ln (1)";
			app.Priority = -3;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "10785 Queensland St (1)";
			app.Priority = -4;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "1237 25th St (1)";
			app.Priority = -5;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "3569 Veteran Ave (1)";
			app.Priority = -6;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 28);
			app.EndTime = new DateTime(2019, 11, 29);
			app.HeaderText = "242 Aderno Way (1)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "8359 Hollywood Blvd (17)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "2788 Monte Mar Ter (14)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			// Dummy item to expand the rows of certain resources
			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "";
			app.Priority = -100;
			_calendar.Schedule.Items.Add(app);

			// Dummy item #2
			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "";
			app.Priority = -100;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 29);
			app.EndTime = new DateTime(2019, 11, 30);
			app.HeaderText = "11301 Wilshire Blvd. (43)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "6200 San Fernando Rd (?)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 29);
			app.EndTime = new DateTime(2019, 11, 30);
			app.HeaderText = "247 W San Bernardino Rd (17)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "1156 Napoli Dr (6)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "1801 San Vicente Blvd (16)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 29);
			app.EndTime = new DateTime(2019, 11, 30);
			app.HeaderText = "245 Maple Dr (7)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 30);
			app.EndTime = new DateTime(2019, 12, 1);
			app.HeaderText = "162 Acari Dr (16)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 27);
			app.EndTime = new DateTime(2019, 11, 28);
			app.HeaderText = "427 Mesa Lila Rd (21)";
			app.Priority = 0;
			_calendar.Schedule.Items.Add(app);

			app = new Appointment();
			app.StartTime = new DateTime(2019, 11, 30);
			app.EndTime = new DateTime(2019, 12, 1);
			app.HeaderText = "2201 Beverly Dr (41)";
			app.Priority = -1;
			_calendar.Schedule.Items.Add(app);
		}
	}
}
